#ifndef ABSREFDIALOG_H
#define ABSREFDIALOG_H

#include <QDialog>
#include <QStandardItemModel>
#include <QSortFilterProxyModel>

typedef struct {
      int   num;        // num. d'ordine del rifless
      int   hkl[3];     // h,k,l
      char  string[51]; // stringa con operatore e condizione
      float prob;       // probabilita' di estinzione
      int   ktype;      // singolo (1) o in sovrapposizione (> 1)
               } absref_type;

namespace Ui {
class AbsRefDialog;
}

class AbsRefDialog : public QDialog
{
    Q_OBJECT

public:
    explicit AbsRefDialog(QWidget *parent = nullptr);
    ~AbsRefDialog();
    void updateAbsRefList(int selectedSpace);

private slots:
    void on_AbsRefDialog_finished(int);

private:
    Ui::AbsRefDialog *ui;
    QStandardItemModel *absRefModel;
    QSortFilterProxyModel *absRefProxyModel;
};

#endif // ABSREFDIALOG_H
