#ifndef GEOCALC_H
#define GEOCALC_H

#include <QDialog>
#if defined(JAV_WIDGET)
class CrystalViewWidget;
#else
class JavWindow;
#endif

namespace Ui {
class GeoCalc;
}

class GeoCalc : public QDialog
{
    Q_OBJECT

public:
    explicit GeoCalc(QWidget *parent = 0);
    ~GeoCalc();
    void setHint(QString msg);
    void setRes(QString res);
    void clear();

private:
    Ui::GeoCalc *ui;
#if defined(JAV_WIDGET)
    CrystalViewWidget *jav;
#else
    JavWindow *jav;
#endif

private slots:
    void on_radioDist_toggled(bool checked);
    void on_radioAngle_toggled(bool checked);
    void on_radioTors_toggled(bool checked);

protected:
    void reject() override;
};

#endif // GEOCALC_H
