#ifndef MYSLIDER_H
#define MYSLIDER_H
#include <QWidget>
#include <QGroupBox>
#include <QHBoxLayout>
#include <QSlider>
#include <QDoubleSpinBox>

class MySlider: public QWidget
{
    Q_OBJECT

public:
    explicit MySlider(QWidget *parent = 0, int k=-1, double min_val=0,
		    double max_val=1, double val=0.1, double step=0.2,
		    int ndec=2);
    explicit MySlider(QWidget *parent = 0, int k=-1, int min_val=0,
		    int max_val=100, int val=0, int step=1);
    ~MySlider() = default;
    static void syncAll(QWidget *parentW, double val, int z);
    static bool do_emit;

private:
    double m_value;
    int m_ivalue;
    int m_z;
    QHBoxLayout *m_layout;
    QDoubleSpinBox *m_spin;
    QSpinBox *m_ispin;
    QSlider *m_slider;
    void on_Slider_valueChanged(int value);
    void on_SpinBox_valueChanged(double arg1);
    void on_IntSlider_valueChanged(int value);
    void on_IntSpinBox_valueChanged(int arg1);
    void DoubleSpinToSlider(double value, const QDoubleSpinBox* doubleSpin, QSlider* slider);
    void SliderToDoubleSpin(int value, const QSlider* slider, QDoubleSpinBox* doubleSpin);

signals:
    void sliderChanged(double value, int k=-1);
    void intSliderChanged(int value, int k=-1);
};
#endif
