#ifndef PAIRDISTSETTINGS_H
#define PAIRDISTSETTINGS_H

#include <QDialog>
#include <QStatusBar>

namespace Ui {
class PairDistSettings;
}

typedef struct {
    int   rad;
    float rmax;
    float qmax;
               } pdf_option_type;

class PairDistSettings : public QDialog
{
    Q_OBJECT

public:
    explicit PairDistSettings(QStatusBar *bar, QWidget *parent = 0);
    ~PairDistSettings();
    void FillForm(int wm, pdf_option_type *pdf);

private:
    Ui::PairDistSettings *ui;
    void ReadForm(pdf_option_type *pdf);
    pdf_option_type *pdfG;
    int m_Model;
    QStatusBar *mBar;

private slots:
    void on_okButton_clicked();
    void on_applyButton_clicked();
    void on_closeButton_clicked();
};

extern "C" void jav_pdf_(int *km, pdf_option_type *pdf);

#endif // PAIRDISTSETTINGS_H
