#ifndef PROPERTIES_H
#define PROPERTIES_H

#include <vector>
#include "libmatrix.h"
#include "models.h"
#include "maps.h"
#include "colorwidget.h"

enum {param_SUPPORT, param_ENABLE, param_BUFFERS};

enum lights {JAV_LIGHT0=0, JAV_LIGHT1, JAV_AMBIENT};

class Properties
{
public: 
      static int Width;
      static int Height;
      static float npixels;
      static unsigned int iTexture[2];
      static int defaultCell;
      static int defaultPlotStyle;
      static int defaultSymmetry;
      static int defaultLabels;
      static int defaultColor;
      static int defaultModify;
      static int defaultBG;
      static QColor defaultBgColor;
      static QColor defaultBgColor1;
      static QColor defaultBgColor2;
      static int defaultFog;
      static int defaultClip;
      static bool defaultDrawPar;
      static vet3 defaultV0;
      static vet3 defaultabc;
      static bool calcRmI;
      static int inModify;
      static int Normalized;
      static int border;
      static float Scale;
      static double ClipFactor;
      static double FogDensity;
      static int subdivisions;
      static int smooth;                // line smooth for antialiased lines
      static bool CenterOnMap;
      static bool Clip;
      static bool Stereo;
      static int  glasses_type;
      static int Xstart;
      static int Ystart;
      static bool ifOrtho;
      static bool oldOrtho;
      static bool ifCell;
      static bool ifGrid;
      static int  nDivisions;
      static bool normalToV;
      static int  GridPattern;
      static bool Fog;
      static float xmin;
      static float xmax;
      static float ymin;
      static float ymax;
      static float zmin;
      static float zmax;
      static float deltav;
      static vet3  Xd;
      static vet3  obj_pos;
      static int   nModels;
      static int   nMaps;
      static int   activeMap;
      static float Cell[6];
      static float CellR[6];
      static _SymmInfo sy;
      static float CellN[6];
      static float Radius;
      static bool  ifWhole;
      static double cylinder;
      static double sc_atoms;
      static double sc_bonds;
      static double sc_bonds0;
      static bool   ShowMultBonds;
      static double scale_atoms[N_ELEMENTS+1];
      static int    ell_tr;
      static int    ell_prob;
      static bool   ell_princ;
      static QColor ell_color;
      static bool   ell_hydro;
      static bool   RadType;
      static vet3  vc[8];    // vertici cella
      static vet3  vcN[8];
      static vet3  xyzsN[4];
      static mat3x3 rmC;
      static mat3x3 rmI;
      static mat3x3 MMRec;
      static mat3x3 om;
      static mat3x3 omI;
      static vet3  xyzC;
      static vet3  abcPar;
      static vet3  VertPar[8];
      static vet3  VertParN[8];
      static bool  ifDrawPar;
      static double eq0[4];
      static double eq1[4];
      static bool  DrawCenter;
      static bool  ifAxes;
      static bool  ifDrawAxes;
      static QColor CellColor;
      static QColor AxesColor;
      static QColor CentreColor;
      static QColor BgColor;
      static QColor BgColor1;
      static QColor BgColor2;
      static QColor ColorHB; 
      static QColor ColorSC;
      static QColor DistColor;
      static ColorWidget::ColorType BgType;
      static _LightInfo lightInfo[3];
      static QColor Colori[NUM_COLORS];
      static int usedC[MAX_NUM_MAPS];
      static bool mapvisSav[MAX_NUM_MAPS];
      static bool modelvisSav[MAX_NUM_MODELS];
      static bool ShowLegend;
      static int  nLegends;
      static int  activeLegend;
      static int  ListaSpecies[MAX_NUM_MODELS*MAX_SPECIES];
      static int  NSpecies;
      static bool ifGrow;
      static bool ifHBonds;
      static bool ifShortc;
      static bool ifDelHang;
      static double xoffset;
      static double yoffset;
      static QString fontname;
      static bool useDefaultB;
      static std::vector <DistAng_type> DistAng_vet;
      static float sphereRadius;
      static int sphereCentre;
      static float SphereCentre[3];
      static bool DrawSphere;
      static float GBB[16];
      static float sc_factor;
      static Vert SelectionRect[4];
      static bool FromImport;
      static void SetActiveModel(int which) {inModify = which-1;}
      static int  GetActiveModel() {return (inModify+1);}
      static void CalcolaMatrici();
      static vet3 FractToCart(float coord[3]);
      static vet3 CartToFract(float coord[3]);
      static vet3 FractToCart(vet3 coord);
      static vet3 CartToFract(vet3 coord);
      static void CalcPar(vet3 v1, vet3 abc);
      static void calcolava();
      static void AggiornaListaSpecie(std::vector <int>v);
      static void calcolaO(std::vector<double> mini, std::vector<double> maxi);
      static void NormalizzasuModello(Model md, bool fResize);
      static void NormalizzasuMappa(Mappa *map);
      static vet3 Trasforma(vet3 num);
      static void NormalizzasuCella();
      static void RiNormalizzasuModello(Model md, bool fResize);
      static void RiNormalizzasuMappa(Model md[], Mappa map[]);
      static void RiNormalizza(Model md[], Mappa map[], bool fResize=false);
      static void set_usedefaultb(float B[3][3]);
      static mat4x4 ViewPlane(int whichPlane, Model md[]);
      static float *get_coef(int whichPlane, Model md[]);
      static void Initialize();
      static void change_clip_value();
      static void ReadSettings();
      static void WriteSettings();
      static QColor GetColor(int k) {return Colori[k];}
      static void  SetColor(int k, QColor color) {Colori[k]=color;}
      static QString getStringSymm(int *koper, int nops=0);
      static bool IsMSEnabled() {return (MSEnabled!=0);}
      static bool IsMSSupported() {return (MSSupported!=0);}
      static int  MSBuffers() {return (NSamples);}
      static void Set_AA(int param, int val);
      static int  GetAA(int param);
      static void UpdateAA();
      static void SetMSEnabled(bool val) {MSEnabled = val?1:0;}
      static void FillVectSamples(int maxSamples);
      static QVector <int> samples() {return Samples;}
      static void DefaultLights();
      static QColor MapColors[MAX_NUM_MAPS+2];
      static float raggioMappa;
      static float centroMappa[3];
      static bool  defCentro;
      static float modelG[16], projG[16];
      static int viewG[4];
      static void RunMCAll(Model md[], Mappa map[]);
      static void SetCentreCoords(float coords[]) {for(int i=0; i<3; i++)
                                            SphereCentre[i] = coords[i];}
      static bool ifDesaturate() {return (Properties::Stereo && (Properties::BgType < ColorWidget::TYPE_FLAT));}
      
private:
      static int  MSSupported;
      static int  MSEnabled;
      static int  NSamples;
      static QVector<int> Samples;
}
;

#endif
