#ifndef RESTRAINTSDIALOG_H
#define RESTRAINTSDIALOG_H

#include "restraintswidget.h"

#include <QAbstractButton>
#include <QDialog>

namespace Ui {
class RestraintsDialog;
}

class RestraintsDialog : public QDialog
{
    Q_OBJECT

public:
    explicit RestraintsDialog(int phId, const QStringList &labels, QWidget *parent = nullptr);
    ~RestraintsDialog();

private slots:
    void actionSaveRestraintsClicked();
    void actionLoadRestraintsClicked();
    void actionTargetButtonClicked();
    void buttonBoxClicked(QAbstractButton *button);

private:
    Ui::RestraintsDialog *ui;
    RestraintsWidget *distResWidget;
    RestraintsWidget *angResWidget;
    RestraintsWidget *planResWidget;
    int phaseId;    
    int targetTypeValue;
    QStringList labAtoms;
    enum restraintType {RESDIST=1, RESANGLE, RESPLANE, ABUMP, RESB};
    void setRestraints(const QVector<crydata::RestraintProperties> &restr, const QStringList &labels, const QVector<double> &wei);
    QVector<crydata::RestraintProperties> getRestraints() const;
    QVector<double> getWeights() const;
    void printRestraints(QTextStream &stream);
};

#endif // RESTRAINTSDIALOG_H
