module screen_mod

contains

   subroutine scr0()  
   USE General
   USE Molcom
   USE plotstyle
   USE fileutil
   USE strutil, only: time_string
   USE prognames
!qt   USE variables, only: cryst
   USE crystal_phase
   USE interop_cpp_for, only: OpenWindow
!
   implicit none
   common /scmess/MessH,Messages
   character *80 MessH,Messages(200)
!qt   character *80 Messaggio
!qt   character *256 str
!qt   integer, parameter   :: NITEMSCRY = 10
!qt   integer, parameter   :: NITEMSDATA = 10
!qt   type(style_type), dimension(NITEMS)     :: styleg
!qt   type(style_type), dimension(NITEMSCRY)  :: stylecryscfg
!qt   type(style_type), dimension(NITEMSDATA) :: styledatacfg
   integer :: iz
!
   if (kscreen.eq.0) return
!
!qt   call styledata%load(styledatacfg)
!
!--open the window
!
   ixv(1)=kscrx
   iyv(1)=kscry
   ixv(2)=0
   ixv(3)=0  
   MessH = package_alt_name//': '//trim(jobname)
!co     call OpenWindow(MessH, iz)
   iz = 0
   if (iz.lt.0) then
      kscreen=0
      call manage_console(1)
      write(0,*)
      write(0,*) '*******************************************'
      write(0,*) '*    The Display cannot be accessed !!!   *'
      write(0,*) '*                                         *'
      write(0,*) '*  Program will go on without graphics    *'
      if (fname(INP_FILE)(1:1).eq.'.')  &
      write(0,*) '* only if a input file has been supplied  *'
      write(0,*) '*******************************************'
      write(0,*)
      call manage_console(2)
      return
   end if
   kscrx=ixv(1)
   kscry=iyv(1)
!qt   FntPixWidth = ixv(2)
!qt   FntPixHeight = iyv(2)
! -
   jscreen = 1
   call OpenWindow()
! -
!  Set MessH for header and for scr2 
   MessH = 'At '//time_string()// ' '//           &
           package_alt_name //' starts on: '//    &
           file_rem_ext(fname(BIN_FILE))
!
   return
   end

!-----------------------------------------------------------------------
   subroutine BeccaSt(ier,file1,file2,nome)
   USE General, only: fname,ext,INP_FILE,OUT_FILE,lo,ifAutomatic
   USE strutil, only: remc0
   USE fileutil
   USE iso_fortran_env
   USE interop_cpp_for, only: cbasename
   USE prog_constants, only: ERR_WINDOW
   USE molcom, only: kscreen
!
   implicit none
   integer, intent(out)            :: ier
   character(len=:), allocatable, intent(inout) :: file1,file2
   character(len=:), allocatable, intent(out)   :: nome
   character(len=len(file1))       :: bfile1
   integer                         :: itype,ier2
   integer                         :: Lung,jop,jopen,iform
   type(file_handle)               :: finp
   character(len=:), allocatable   :: message
   integer                         :: exitcode
!
!--   nome = ' '
   ier = 0
!--
   if (len_trim(file1) /= 0) then
!      get basename (name without path and extension), e.g. pippo.exp -> pippo
       call cBaseName(file1//char(0), bfile1)
       nome = trim(remc0(bfile1))
!
!      Set input file name
       !jsir = index(nome,'.',back=.true.)
!       if (jsir /= 0) then
!           k = jsir - 1
!           nome = bfile1(1:k)
!       else
       !if (jsir == 0) then
       if (.not.has_extension(file1)) then
           !nome = file1
           !k = Lung(nome)
           !file1 = nome(1:k) // ext(INP_FILE)
           !k = Lung(bfile1)
           !nome = bfile1(1:k)
           file1 = nome // ext(INP_FILE)
       endif
!
!      Try open the input file
       call finp%fopen(file1)
       if (finp%good()) then
           call finp%fclose()
       else
           Message = ' Cannot open: '//trim(file1) &
           //char(10)//' Message: '//trim(finp%err_msg())
           call MsgWinErr('ERROR',Message,ERR_WINDOW,exitcode)        
           !write(ERROR_UNIT,'(a)')' Cannot open: '//trim(file1) &
           !//char(10)//' Message: '//trim(finp%err_msg())
!!!!FIX: reset file1 and file2? Avoid close program with GUI
           file1 = ""
           ier = -2
       endif
!
!      Set output file name
!corr       if (file2(1:1).eq.' ') then
       if (len_trim(file2) == 0) then
           if (extension_is(file1,ext(OUT_FILE)(2:))) then !check if input has 'out' extension
               !file2 = trim(nome)//'_1'//ext(OUT_FILE)
               file2 = nome //'_1'//ext(OUT_FILE)
           else
               !file2=trim(nome)//ext(OUT_FILE)
               file2= nome // ext(OUT_FILE)
           endif
       end if
   endif
!--
   if (ier.lt.0) then
!      Do not notify error if GUI is available
       if (kscreen == 1 .and. ifAutomatic == 0) ier = 0
       return
   endif
!--
   itype = 0
   iform = 1
   if (len_trim(file2) /= 0) then
   !if (file2(1:1).ne.' ') then
       jop = jopen(lo,file2,itype,iform,ier2)
       if (jop.lt.0) then
           ier = -1
           write(lo,500) ier2,file2(1:Lung(file2))
           500 format(' *** error ***  open error, code =',i5,' file is ',a)
       endif
   endif
! -
   fname(INP_FILE) = file1
   fname(OUT_FILE) = file2
!
   return
   end

end module screen_mod

!--------------------------------------------------------------------
   subroutine scrper(line,iperc,nperc,kprocess)
   USE Molcom, only: kscreen
   USE messagemod
   implicit none
   character(len=*), intent(in) :: line
   integer, intent(in)          :: iperc,nperc
   integer, intent(in)          :: kprocess
!
   if (kscreen.eq.0) return

   if (iperc.eq.0) then
     call progressbar_set_visible(0,kprocess)
   endif
!
   if (len_trim(line) > 0) then
     call progressbar_set_message(trim(line)//char(0),kprocess)
   endif
!
   if (iperc.eq.0) then
       if (nperc.eq.0) then
           call progressbar_set_visible(0,kprocess)
       endif
   else
        call progressbar_set_value(iperc,nperc,kprocess)
   endif
!
!mrcall zflush
!
   return
   end

!------------------------------------------------------------------------------------------------------------

   subroutine write_message_found(pos,kproc)
   USE strutil
   USE TestModel
   USE messagemod
   implicit none
   integer, intent(in) :: pos
   integer, intent(in) :: kproc
   call write_message('Found:'//trim(i_to_s(int(vett_test(3))))//'/'//trim(i_to_s(int(vett_test(1))))//   &
   ' dist: '//trim(r_to_s(vett_test(4),3)),pos=pos,kproc=kproc)
   end subroutine write_message_found

!-----------------------------------------------------------------------------------------------------------

   subroutine write_message_found1(pos,natfound,natpub,rmsd)
   USE strutil
   USE messagemod
   implicit none
   integer, intent(in) :: pos
   integer, intent(in) :: natfound,natpub
   real, intent(in)    :: rmsd
   call write_message('Found:'//trim(i_to_s(natfound))//'/'//trim(i_to_s(natpub))//   &
   ' RMSD: '//trim(r_to_s(rmsd,3)),pos=pos)
   end subroutine write_message_found1

!------------------------------------------------------------------------------------------------------------

   subroutine scrp(itrial,maxtr,cfom,cfomx)
   USE Molcom
   USE commandsmod, only:allcom
   USE messagemod
   USE strutil
   implicit none
   integer, intent(in) :: itrial,maxtr
   real, intent(in)    :: cfom,cfomx
   common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
   integer :: icomq,maxcom,ipcom,ipdir,icomat
   character *80 MessH,Messages(200)
   common /scmess/MessH,Messages
   common/cris/numcri,jcran,maxtri,nstart,muset,nfixed,inumber,ifirst
   integer :: numcri,jcran,maxtri,nstart,muset,nfixed,inumber,ifirst
   integer :: j
   real    :: ccfmx
!
   if (kscreen.eq.0) return
   if (mod(itrial,10) == 0) then

       call SetRowCountMesg(3,0)
!
!qt       str = ' '
!
       j=icomq(icomat,1)
!qt       str(1:14)=allcom(j)
       if (cfomx.lt.0.0) then
          ccfmx=0.0
       else
          ccfmx=cfomx
       endif
!qt       if (inumber.eq.0) then
!qt          write(str(15:64),10) itrial,maxtr,cfom,ccfmx
!qt       else
!qt          write(str(15:79),20) inumber,maxtri,itrial,maxtr,cfom,ccfmx
!qt       end if
!qt    10 format('Trial ',i4,' / ',i4,'  CFom = ',f6.3,'  (max = ',f6.3,') ')
!qt    20 format('Set ',i4,' / ',i4,' Trial ',i4,' / ',i4,'  CFom = ',f6.3,'  (max = ',f6.3,') ')
!qt       iz = lung(str)
!qt       call scr2()
       if (inumber == 0) then    
           call write_message('Trial:'//trim(i_to_s(itrial))//'/'//trim(i_to_s(maxtr)),pos=2,kproc=0)
           call write_message('CFom:'//trim(r_to_s(cfom,3))//' (max ='//trim(r_to_s(ccfmx,3))//')',pos=3,kproc=1)
       else
           call write_message('Set:'//trim(i_to_s(inumber))//'/'//trim(i_to_s(maxtri)),pos=2,kproc=0)
           call write_message('Trial:'//trim(i_to_s(itrial))//'/'//trim(i_to_s(maxtr)),pos=3,kproc=0)
           call write_message('CFom:'//trim(r_to_s(cfom,3))//' (max ='//trim(r_to_s(ccfmx,3))//')',pos=4,kproc=1)
       endif
   endif
   return
   end

!------------------------------------------------------------------------------------------------------------

   subroutine write_message_pattern(filepow)
   USE counts, only:dvalue
   USE patternref, only:thmax, thmin
   USE messagemod
   USE conteggi, only:npunti
   USE General, only:nrefl, alambda
   USE molcom, only:jscreen
   implicit none
   character(len=*), intent(in) :: filepow
   integer                      :: pos
!
   if (jscreen == 0) return
!
   if (nrefl > 0) then
       call SetRowCountMesg(8,1)
   else
       call SetRowCountMesg(7,1)
   endif
   call write_message('Data file:'//trim(filepow),pos=2,kproc=0)
   call write_message('2-theta min.:',rnum=thmin,pos=3,kproc=0)
   call write_message('2-theta max.:',rnum=thmax,pos=4,kproc=0)
   call write_message('Ncounts:',inum=npunti,pos=5,kproc=0)
   call write_message('Resolution:',rnum=dvalue(thmax,alambda),pos=6,kproc=0)
   pos = 6
   if (nrefl > 0) then
       pos = pos + 1
       call write_message('Reflections nr.:',inum=nrefl,pos=pos,kproc=0)
   endif
   pos = pos + 1
   call write_message('Wavelength:',rnum=alambda,pos=pos,dig=5,kproc=1)
!
   end subroutine write_message_pattern

!------------------------------------------------------------------------------------------------------------

   subroutine write_message_peak() 
   use peak_mod
   use messagemod
   integer(c_int) :: pos
!
   pos = rowFindMesg(c_char_"Number of peaks:"//c_null_char)
   if (pos == 0) then
       pos = getRowCountMesg() + 1
   endif
   call write_message('Number of peaks:',inum=numpeaks(pkind),pos=pos)
!
   end subroutine write_message_peak

!------------------------------------------------------------------------------------------------------------

   subroutine write_inte_routine(routine)
   USE General, only: jobname,lo
   USE strutil
   USE prognames
   USE mpi_prog
   character(len=*), intent(in) :: routine
   character(len=80), dimension(3) :: title
   character(len=80)               :: str
!
   if (mpi_prog_rank /= mpi_prog_master) return
!
   write(lo,'(//)')
   str = 'Release: '//version
   title(1) = adjustr(title(1))
   title(1) = package_alt_name//': '//trim(routine)//' routine'
   title(1)(len(title) - len_trim(str) -1 :) = str
   title(2) = ' '
   title(3) = trim(jobname)
   call write_title(lo,title,(/'l','l','c'/))
   write(lo,'(/)')
!
   end subroutine write_inte_routine

!------------------------------------------------------------------------------------------------------------

   subroutine CheckWindowCommand(file1,nkscrx,nkscry,Titolo,ier)
   USE General, only: jobname
   USE Molcom, only: kscreen
   USE commandsmod, only:beg,commen
   implicit none
!
   character(len=*), intent(in)  :: file1
   integer, intent(out)          :: nkscrx, nkscry, ier
   character(len=*), intent(out) :: Titolo
   common /SizeScr/ MinScX, MaxScX, MinScY, MaxScY
   integer ::  MinScX, MaxScX, MinScY, MaxScY
   character line*80, dire*80, com3*3
   real, dimension(40)    :: vet
   integer, dimension(40) :: ivet
   integer :: nchar, iv, jop, ier1, iform, itype, ifEnd, ifJob
   integer :: ioffset, iopt, k, lend, lenp, jopen, kform
!
   ier = 0
   ifJob = 0
   itype = 2
   iform = 1
   jop = jopen(kform,file1,itype,iform,ier1)
   ifEnd = 0
   nkscrx = 0
   nkscry = 0
!
   do while ( ifEnd.eq.0)
      read(kform,'(a)',end=20) line
      k = index(line,'!')
      if (k.ne.0) then
          line(k:) = ' '
      endif
      call shift(line,nchar)
      if (nchar.gt.0.and.line(1:1).ne.commen) then
          if (line(1:1).eq.beg) then
              com3=line(2:4)
              call lcase(com3)
!
              if (com3.eq.'end'.or.com3.eq.'con'.or.com3.eq.'men') then
                  ifEnd = 1
              else if (com3.eq.'win') then
                  kscreen = 1
                  call cutst(line,lenp,dire,lend)
                  iopt=0
                  call getnum(line,vet,ivet,iv,iopt)
                  if (iv.eq.2) then
                      if (ivet(1).gt.MinScX) then
                          nkscrx = ivet(1)
                      endif
                      if (ivet(2).gt.MinScY) then
                          nkscry = ivet(2)
                      endif
                  endif
              else if (com3.eq.'now') then
                  kscreen = 0
              else if (com3.eq.'job') then
                  call cutst(line,lenp,dire,lend)
                  if (len_trim(line) == 0) cycle ! %job whitout string
                  ioffset = ( 80 - lenp ) / 2
                  if (ioffset.le.0) ioffset = 1
                  dire = ' '
                  dire(ioffset:) = line
                  jobname = trim(line)
                  Titolo = adjustl(dire)
                  ifJob = 1
              endif
          endif
      endif
   enddo
20 continue
!
   close(kform)
!
   if (ifJob == 0) then
       Titolo = trim(file1)
   endif
!
   return
   end
