#ifndef SPACEGROUPWIDGET_H
#define SPACEGROUPWIDGET_H

#include "sg_database.h"

#include <QWidget>
#include <QStringListModel>

namespace Ui {
class SpaceGroupWidget;
}

class SpaceGroupWidget : public QWidget
{
    Q_OBJECT

public:
    explicit SpaceGroupWidget(QWidget *parent = nullptr);
    ~SpaceGroupWidget();
    void setSpaceGroup(int index, const QString &spg);
    int getSpaceGroup(QString &spg) const;
    bool isValidSpaceGroup() const;

private slots:
    void on_systemComboBox_currentIndexChanged(int index);
    //void on_spacegComboBox_currentIndexChanged(int index);

signals:
    void spaceGroupChanged(const QString &spg);

private:
    Ui::SpaceGroupWidget *ui;
    QStringListModel *sgModel;
    int sgListIndex;
    void fillCombo(sgdat::CrystalSystem csys);
};

#endif // SPACEGROUPWIDGET_H
