#ifndef  STLUTILS_H
#define STLUTILS_H
#include <cstdio>
#include <cstring>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <algorithm>
#include <vector>

#include "libmath.h"
#include "libvector.h"

using namespace std;
typedef struct {
                double v1[3], v2[3], v3[3];
                double vn[3];
                int nat;
               } Triangolo;

        #define XC .525731112119133606 
        #define ZC .850650808352039932


        #define HEADER_SIZE 80

        class STL_class
        {
                public:
                        size_t NumTrigs() {return nTrigs;}
                        void drawtri(GLdouble *a, GLdouble *b, GLdouble *c,
                                      int div, double r, int nat);
                        bool readSTL();
                        void DrawTriangles(QOpenGLFunctions *m_context);
                        bool readSTL_ASCII(vector<double> &tvet);
                        bool readSTL_BIN(vector<double> &tvet);
                        void setFile(string fn) {filename=fn;}
                        void PrintSferaSTL(int nat, double radius, int ndiv);
                        void writeSTL(vector<vet3> &xyz);
                        void ClearTrigs(){trigs.clear(); nTrigs=0;}
                        void AddTrig(Triangolo tr1) {trigs.push_back(tr1);}
                        void Pol2Trigs(vet3 v[4]);
                        void TFVert2Tri(vector<vet3> Vertici);
                        void QSVert2Tri(vector<vet3> Vertici);
                        void PrintCilindroSTL(vet3 p1, vet3 p2, double raggio);

                private:
                        vector<Triangolo> trigs;
                        size_t nTrigs = 0;
			string filename;
        };

        void importSTL(string &fn);
        void StartExport();
        void EndExport(QString fn, std::vector<vet3> &xyzat);
        bool DrawTrigs(QOpenGLFunctions *m_context);
#endif
